Custom headers for React DataManager

14 Apr 20266 minutes to read

Custom headers provide a mechanism to send additional information along with HTTP requests made by the Syncfusion® DataManager. These headers can include authentication tokens, API keys, session identifiers, or any other metadata required by the server to validate and process the request correctly.

The Syncfusion® DataManager supports custom headers through its headers property, enabling secure and flexible communication between the client application and the server. This feature is particularly useful when requests must carry additional information for authentication, authorization, or contextual processing.

Steps to integrate custom headers into DataManager requests:

  1. Create a new instance of DataManager with the required URL and adaptor.

  2. Assign the custom headers to the headers property of the DataManager instance.

  3. Trigger the executeQuery method to send the request to the server with the custom headers.

import React, { useEffect, useState } from 'react';
import { DataManager, ODataV4Adaptor, Query } from '@syncfusion/ej2-data';

const Row = ({ item }) => {
  return (
    <tr>
      <td>{item.OrderID}</td>
      <td>{item.CustomerID}</td>
      <td>{item.EmployeeID}</td>
    </tr>
  );
};

const SERVICE_URL = 'https://services.syncfusion.com/react/production/api/Orders';

const App = () => {
  const [items, setItems] = useState([]);

  useEffect(() => {
    const dataManager = new DataManager({
      url: SERVICE_URL,
      adaptor: new ODataV4Adaptor(),
      headers: [{ 'syncfusion-data-manager': 'true' }],
    });
    dataManager.executeQuery(new Query()).then((e) => {
      const results = e && e.result ? e.result : [];
      setItems(results);
    });
  }, []);

  return (
    <table id="datatable" className="e-table">
      <thead>
        <tr>
          <th>Order ID</th>
          <th>Customer ID</th>
          <th>Employee ID</th>
        </tr>
      </thead>
      <tbody>
        {items.map((row) => (
          <Row key={row.OrderID} item={row} />
        ))}
      </tbody>
    </table>
  );
};

export default App;
import * as React from 'react';
import { useEffect, useState } from 'react';
import { DataManager, ODataV4Adaptor, Query } from '@syncfusion/ej2-data';

interface Order {
  OrderID: number;
  CustomerID?: string;
  EmployeeID?: number;
  [key: string]: any;
}
function Row({ item }: { item: Order }) {
  return (
    <tr>
      <td>{item.OrderID}</td>
      <td>{item.CustomerID}</td>
      <td>{item.EmployeeID}</td>
    </tr>
  );
}
const SERVICE_URL: string = 'https://services.syncfusion.com/react/production/api/Orders';

const App: React.FC = () => {
  const [items, setItems] = useState<Order[]>([]);

  useEffect(() => {
    const dataManager: DataManager = new DataManager({
      url: SERVICE_URL,
      adaptor: new ODataV4Adaptor(),
      headers: [{ 'syncfusion-data-manager': 'true' }],
    });

    dataManager.executeQuery(new Query()).then((e: any) => {
      const results: Order[] = e && e.result ? e.result : [];
      setItems(results);
    });
  }, []);

  return (
    <table id="datatable" className="e-table">
      <thead>
        <tr>
          <th>Order ID</th>
          <th>Customer ID</th>
          <th>Employee ID</th>
        </tr>
      </thead>
      <tbody>
        {items.map((row) => (
          <Row key={row.OrderID} item={row} />
        ))}
      </tbody>
    </table>
  );
};

export default App;

Adding custom headers with Vue DataManager

27 Sep 20266 minutes to read

Custom headers allow you to send extra information along with your HTTP requests. This information can include authentication tokens, API keys, or any other data required by the server to process the request correctly. By adding custom headers, you can enhance the security and functionality of your application’s data communication process.

The Syncfusion® DataManager provides a flexible way to include custom HTTP headers in your data requests through the headers property, enhancing communication between your application and the server. This feature is particularly useful when you need to include additional information or authentication tokens in your data requests.

To integrate custom headers into your DataManager requests, follow these steps:

  1. Create a new instance of DataManager with the required URL and adaptor.

  2. Assign the custom headers to the headers property of the DataManager instance.

  3. Trigger the executeQuery method to send the request to the server with the custom headers.

<template>
  <div id="app">
    <table class='e-table'>
      <tr><th>Order ID</th><th>Customer ID</th><th>Employee ID</th></tr>
      <tr v-for="(item, index) in items" :key="index">
        <td>{{ item.OrderID }}</td>
        <td>{{ item.CustomerID }}</td>
        <td>{{ item.EmployeeID }}</td>
      </tr>
    </table>  
  </div>
</template>

<script setup>
import { onMounted, ref } from "vue";
import { DataManager, Query, ODataAdaptor } from '@syncfusion/ej2-data';

const items = ref([]);

onMounted(() => {
  let SERVICE_URI = "https://services.syncfusion.com/vue/production/api/Orders";
  let dataManager = new DataManager({ 
      url: SERVICE_URI, 
      adaptor: new ODataAdaptor, 
      headers:[{ 'syncfusion-data-manager': 'true' }]  
  });
  dataManager.executeQuery(new Query()).then((e) => {
    this.items = e.result;
  });
})
</script>

<style>
  .e-table {
    border: solid 1px #e0e0e0;
    border-collapse: collapse;
    font-family: Roboto;
  }

  .e-table td, .e-table th {
    border-style: solid;
    border-width: 1px 0 0;
    border-color: #e0e0e0;
    display: table-cell;
    font-size: 14px;
    line-height: 20px;
    overflow: hidden;
    padding: 8px 21px;
    vertical-align: middle;
    white-space: nowrap;
    width: auto;
  }
</style>
<template>
  <div id="app">
    <table class='e-table'>
      <tr><th>Order ID</th><th>Customer ID</th><th>Employee ID</th></tr>
      <tr v-for="(item, index) in items" :key="index">
        <td>{{ item.OrderID }}</td>
        <td>{{ item.CustomerID }}</td>
        <td>{{ item.EmployeeID }}</td>
      </tr>
    </table>  
  </div>
</template>

<script>
import { DataManager, Query, ODataAdaptor } from '@syncfusion/ej2-data';

export default {
  data() {
    return {
      items: [] 
    };
  },
  mounted() {
    let SERVICE_URI = "https://services.syncfusion.com/vue/production/api/Orders";
    let dataManager = new DataManager({ 
        url: SERVICE_URI, 
        adaptor: new ODataAdaptor, 
        headers:[{ 'syncfusion-data-manager': 'true' }]  
    });
    dataManager.executeQuery(new Query()).then((e) => {
      this.items = e.result;
    });
  }
}
</script>

<style>
  .e-table {
    border: solid 1px #e0e0e0;
    border-collapse: collapse;
    font-family: Roboto;
  }

  .e-table td, .e-table th {
    border-style: solid;
    border-width: 1px 0 0;
    border-color: #e0e0e0;
    display: table-cell;
    font-size: 14px;
    line-height: 20px;
    overflow: hidden;
    padding: 8px 21px;
    vertical-align: middle;
    white-space: nowrap;
    width: auto;
  }
</style>
  • Headers can be defined as key-value pairs.
  • Adding custom headers while making cross domain request will initiate preflight request.